#!/usr/bin/perl
# quick hack job to get the failures into an html
# format for the Cairo folks to review

print "<html>\n";
print "<table border=\"1\">\n";
print "<tr><td>Count</td>\n";
print "<td>Test</td>\n";
print "<td>Ref</td>\n";
print "<td>Out</td>\n";
print "<td>Diff</td>\n";
print "<td>Log</td></tr>\n";

my @bads = `grep -l Error *.log`;
chomp @bads;

my @fails = `/opt/lsb-tet3-lite/bin/tjreport journal.cairo | grep ' FAIL' | awk '{print \$1}'`;
chomp @fails;

mkdir "html_source";
my $counter = 0;

for my $bad (@fails) {
  $counter++;
  $prefix = $bad;
  $prefix =~ s/-xlib|-image//;
  print "<tr>\n";
  print "<td>$counter:</td>";
  print "<td>$prefix</td>\n";
  my $ref = $prefix . "-ref.png";
  `cp $ref html_source`;
  my $iout = $prefix . "-image-out.png";
  my $idiff = $prefix . "-image-diff.png";
  my $xout = $prefix . "-xlib-out.png";
  my $xdiff = $prefix . "-xlib-diff.png";
  my $log = `cat $prefix.log`;
  `cp $prefix.log html_source`;
  print "<td><a href=\"$ref\">$ref</a></td>\n";
  print "<td>";
  if ($bad =~ /image/) { 
    print "<a href=\"$iout\">$iout</a>";
    `cp $iout html_source`;
  }
  print "<br>";
  if ($bad =~ /xlib/) {
    print "<a href=\"$xout\">$xout</a>";
    `cp $xout html_source`;
  }
  print "</td>\n"; 
  print "<td>";
  if ($bad =~ /image/) { 
    print "<a href=\"$idiff\">$idiff</a>";
    `cp $idiff html_source`;
  }
  print "<br>";
  if ($bad =~ /xlib/) {
    print "<a href=\"$xdiff\">$xdiff</a>";
    `cp $xdiff html_source`;
  }
  print "</td>\n"; 
  print "<td><pre>$log</pre></td>";
  print "</tr>\n"; 
}

print "</table>\n";
print "</html>\n";
 
